searchNodes=[{"doc":"Documentation for PactElixir.","ref":"PactElixir.html","title":"PactElixir","type":"module"},{"doc":"","ref":"PactElixir.html#like/1","title":"PactElixir.like/1","type":"function"},{"doc":"","ref":"PactElixir.html#term/1","title":"PactElixir.term/1","type":"function"},{"doc":"This module can be imported to create and start a mock server with the usual Pact DSL.","ref":"PactElixir.Dsl.html","title":"PactElixir.Dsl","type":"module"},{"doc":"Adds an interaction to the pact.","ref":"PactElixir.Dsl.html#add_interaction/5","title":"PactElixir.Dsl.add_interaction/5","type":"function"},{"doc":"Verifies interactions and shuts the mock server down. To be called after test suite run in main application, eg. in an on_exit callback: on_exit(fn -&gt; after_test_suite(provider) end)","ref":"PactElixir.Dsl.html#after_test_suite/1","title":"PactElixir.Dsl.after_test_suite/1","type":"function"},{"doc":"","ref":"PactElixir.Dsl.html#build/1","title":"PactElixir.Dsl.build/1","type":"function"},{"doc":"","ref":"PactElixir.Dsl.html#given/1","title":"PactElixir.Dsl.given/1","type":"function"},{"doc":"Returns URL of the mock server host, eg. &quot; http://localhost:54321&quot;","ref":"PactElixir.Dsl.html#mock_server_host_url/1","title":"PactElixir.Dsl.mock_server_host_url/1","type":"function"},{"doc":"","ref":"PactElixir.Dsl.html#mock_server_matched?/1","title":"PactElixir.Dsl.mock_server_matched?/1","type":"function"},{"doc":"","ref":"PactElixir.Dsl.html#mock_server_mismatches/1","title":"PactElixir.Dsl.mock_server_mismatches/1","type":"function"},{"doc":"","ref":"PactElixir.Dsl.html#service_provider/1","title":"PactElixir.Dsl.service_provider/1","type":"function"},{"doc":"","ref":"PactElixir.Dsl.html#shut_down_mock_server/1","title":"PactElixir.Dsl.shut_down_mock_server/1","type":"function"},{"doc":"","ref":"PactElixir.Dsl.html#verify_interactions/1","title":"PactElixir.Dsl.verify_interactions/1","type":"function"},{"doc":"","ref":"PactElixir.Dsl.html#will_respond_with/1","title":"PactElixir.Dsl.will_respond_with/1","type":"function"},{"doc":"","ref":"PactElixir.Dsl.html#with_request/1","title":"PactElixir.Dsl.with_request/1","type":"function"},{"doc":"Currently this is the whole error handling stuff.","ref":"PactElixir.Errors.html","title":"PactElixir.Errors","type":"module"},{"doc":"","ref":"PactElixir.Errors.html#convert_to_error/1","title":"PactElixir.Errors.convert_to_error/1","type":"function"},{"doc":"","ref":"PactElixir.Errors.html#map_to_string/1","title":"PactElixir.Errors.map_to_string/1","type":"function"},{"doc":"","ref":"PactElixir.Errors.html#type_to_name/1","title":"PactElixir.Errors.type_to_name/1","type":"function"},{"doc":"Defines the expected interactions with a provider.","ref":"PactElixir.Interaction.html","title":"PactElixir.Interaction","type":"module"},{"doc":"","ref":"PactElixir.Interaction.html#to_json/1","title":"PactElixir.Interaction.to_json/1","type":"function"},{"doc":"GenServer callbacks for managing a pact mock server. Used in conjunction with PactMockServer.","ref":"PactElixir.MockServerCallbacks.html","title":"PactElixir.MockServerCallbacks","type":"module"},{"doc":"","ref":"PactElixir.MockServerCallbacks.html#handle_call/3","title":"PactElixir.MockServerCallbacks.handle_call/3","type":"function"},{"doc":"","ref":"PactElixir.MockServerCallbacks.html#init/1","title":"PactElixir.MockServerCallbacks.init/1","type":"function"},{"doc":"","ref":"PactElixir.MockServerCallbacks.html#matched?/1","title":"PactElixir.MockServerCallbacks.matched?/1","type":"function"},{"doc":"","ref":"PactElixir.MockServerCallbacks.html#mismatches/1","title":"PactElixir.MockServerCallbacks.mismatches/1","type":"function"},{"doc":"","ref":"PactElixir.MockServerCallbacks.html#start/1","title":"PactElixir.MockServerCallbacks.start/1","type":"function"},{"doc":"","ref":"PactElixir.MockServerCallbacks.html#start/2","title":"PactElixir.MockServerCallbacks.start/2","type":"function"},{"doc":"","ref":"PactElixir.MockServerCallbacks.html#terminate/2","title":"PactElixir.MockServerCallbacks.terminate/2","type":"function"},{"doc":"","ref":"PactElixir.MockServerCallbacks.html#write_pact_file/1","title":"PactElixir.MockServerCallbacks.write_pact_file/1","type":"function"},{"doc":"","ref":"PactElixir.MockServerCallbacks.html#write_pact_file_with_error_handling/2","title":"PactElixir.MockServerCallbacks.write_pact_file_with_error_handling/2","type":"function"},{"doc":"Supervises PactMockServers so that they can be controlled even after the test suite has finished. The Supervisor does not restart a failed PactMockServer as the information like successful requests is stored only there and therefor lost.","ref":"PactElixir.MockServerSupervisor.html","title":"PactElixir.MockServerSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"PactElixir.MockServerSupervisor.html#child_spec/1","title":"PactElixir.MockServerSupervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for DynamicSupervisor.init/1 .","ref":"PactElixir.MockServerSupervisor.html#init/1","title":"PactElixir.MockServerSupervisor.init/1","type":"function"},{"doc":"","ref":"PactElixir.MockServerSupervisor.html#start_link/1","title":"PactElixir.MockServerSupervisor.start_link/1","type":"function"},{"doc":"","ref":"PactElixir.MockServerSupervisor.html#start_mock_server/1","title":"PactElixir.MockServerSupervisor.start_mock_server/1","type":"function"},{"doc":"","ref":"PactElixir.MockServerSupervisor.html#terminate_child/1","title":"PactElixir.MockServerSupervisor.terminate_child/1","type":"function"},{"doc":"GenServer client API for managing a pact mock server. Used in conjunction with PactElixir.MockServerCallbacks.","ref":"PactElixir.PactMockServer.html","title":"PactElixir.PactMockServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"PactElixir.PactMockServer.html#child_spec/1","title":"PactElixir.PactMockServer.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"PactElixir.PactMockServer.html#init/1","title":"PactElixir.PactMockServer.init/1","type":"function"},{"doc":"","ref":"PactElixir.PactMockServer.html#matched?/1","title":"PactElixir.PactMockServer.matched?/1","type":"function"},{"doc":"","ref":"PactElixir.PactMockServer.html#mismatches/1","title":"PactElixir.PactMockServer.mismatches/1","type":"function"},{"doc":"","ref":"PactElixir.PactMockServer.html#pact_file_path/1","title":"PactElixir.PactMockServer.pact_file_path/1","type":"function"},{"doc":"","ref":"PactElixir.PactMockServer.html#pact_output_dir_path/1","title":"PactElixir.PactMockServer.pact_output_dir_path/1","type":"function"},{"doc":"","ref":"PactElixir.PactMockServer.html#port/1","title":"PactElixir.PactMockServer.port/1","type":"function"},{"doc":"","ref":"PactElixir.PactMockServer.html#registered_name/1","title":"PactElixir.PactMockServer.registered_name/1","type":"function"},{"doc":"","ref":"PactElixir.PactMockServer.html#service_provider/1","title":"PactElixir.PactMockServer.service_provider/1","type":"function"},{"doc":"","ref":"PactElixir.PactMockServer.html#start_link/1","title":"PactElixir.PactMockServer.start_link/1","type":"function"},{"doc":"","ref":"PactElixir.PactMockServer.html#stop/1","title":"PactElixir.PactMockServer.stop/1","type":"function"},{"doc":"","ref":"PactElixir.PactMockServer.html#write_pact_file/1","title":"PactElixir.PactMockServer.write_pact_file/1","type":"function"},{"doc":"Represent the expected request.","ref":"PactElixir.Request.html","title":"PactElixir.Request","type":"module"},{"doc":"","ref":"PactElixir.Request.html#new/1","title":"PactElixir.Request.new/1","type":"function"},{"doc":"Represent the expected response.","ref":"PactElixir.Response.html","title":"PactElixir.Response","type":"module"},{"doc":"","ref":"PactElixir.Response.html#add_rule/4","title":"PactElixir.Response.add_rule/4","type":"function"},{"doc":"","ref":"PactElixir.Response.html#collect_values_for_body/1","title":"PactElixir.Response.collect_values_for_body/1","type":"function"},{"doc":"","ref":"PactElixir.Response.html#do_matching_rules/3","title":"PactElixir.Response.do_matching_rules/3","type":"function"},{"doc":"","ref":"PactElixir.Response.html#key_for_list_element/2","title":"PactElixir.Response.key_for_list_element/2","type":"function"},{"doc":"","ref":"PactElixir.Response.html#matching_rules/1","title":"PactElixir.Response.matching_rules/1","type":"function"},{"doc":"","ref":"PactElixir.Response.html#new/1","title":"PactElixir.Response.new/1","type":"function"},{"doc":"Adapter for the wrapped rust pact mock server . Functions in this file are replaced by Rustler with their Rust calling counterpart. See native/pactmockserver/src/lib.rs for the concrete Rust implementation. This file is excluded from the coverage tool.","ref":"PactElixir.RustPactMockServerFacade.html","title":"PactElixir.RustPactMockServerFacade","type":"module"},{"doc":"","ref":"PactElixir.RustPactMockServerFacade.html#cleanup_mock_server/1","title":"PactElixir.RustPactMockServerFacade.cleanup_mock_server/1","type":"function"},{"doc":"","ref":"PactElixir.RustPactMockServerFacade.html#create_mock_server/2","title":"PactElixir.RustPactMockServerFacade.create_mock_server/2","type":"function"},{"doc":"","ref":"PactElixir.RustPactMockServerFacade.html#mock_server_matched/1","title":"PactElixir.RustPactMockServerFacade.mock_server_matched/1","type":"function"},{"doc":"","ref":"PactElixir.RustPactMockServerFacade.html#mock_server_mismatches/1","title":"PactElixir.RustPactMockServerFacade.mock_server_mismatches/1","type":"function"},{"doc":"","ref":"PactElixir.RustPactMockServerFacade.html#write_pact_file/2","title":"PactElixir.RustPactMockServerFacade.write_pact_file/2","type":"function"},{"doc":"Represent the remote part (server/provider) for the expected interactions.","ref":"PactElixir.ServiceProvider.html","title":"PactElixir.ServiceProvider","type":"module"},{"doc":"","ref":"PactElixir.ServiceProvider.html#host_url/1","title":"PactElixir.ServiceProvider.host_url/1","type":"function"},{"doc":"","ref":"PactElixir.ServiceProvider.html#new/1","title":"PactElixir.ServiceProvider.new/1","type":"function"},{"doc":"","ref":"PactElixir.ServiceProvider.html#pact_file_path/1","title":"PactElixir.ServiceProvider.pact_file_path/1","type":"function"},{"doc":"","ref":"PactElixir.ServiceProvider.html#to_pact_json/1","title":"PactElixir.ServiceProvider.to_pact_json/1","type":"function"},{"doc":"","ref":"PactElixir.ServiceProvider.html#t:t/0","title":"PactElixir.ServiceProvider.t/0","type":"type"},{"doc":"","ref":"PactElixir.Term.html","title":"PactElixir.Term","type":"module"},{"doc":"","ref":"PactElixir.Term.html#get_my_map/1","title":"PactElixir.Term.get_my_map/1","type":"function"},{"doc":"","ref":"PactElixir.Term.html#term/2","title":"PactElixir.Term.term/2","type":"function"},{"doc":"","ref":"PactElixir.TermDetector.html","title":"PactElixir.TermDetector","type":"module"},{"doc":"","ref":"PactElixir.TermDetector.html#recursively_update_terms/1","title":"PactElixir.TermDetector.recursively_update_terms/1","type":"function"},{"doc":"Allow to match against a type instead of an exact value.","ref":"PactElixir.TypeMatcher.html","title":"PactElixir.TypeMatcher","type":"module"},{"doc":"","ref":"PactElixir.TypeMatcher.html#like/1","title":"PactElixir.TypeMatcher.like/1","type":"function"},{"doc":"","ref":"PactElixir.VerificationError.html","title":"PactElixir.VerificationError","type":"exception"},{"doc":"This library is an Elixir wrapper for the pact-reference implementation And it is in PRE alpha shape without any semantic versioning or documentation. It is not yet usable as many needed parts like publishing a pact file to a broker or pact verification on the provider side are still missing. Also there is no documentation available, yet.","ref":"readme.html","title":"PactElixir","type":"extras"},{"doc":"Discussion about the development of this library takes places in the #pact-elixir Channel at https://pact-foundation.slack.com/ .","ref":"readme.html#development","title":"PactElixir - Development","type":"extras"},{"doc":"You need Rust in order to build and install the package. If available in Hex , the package can be installed by adding pact_elixir to your list of dependencies in mix.exs : def deps do [ { :pact_elixir , &quot;~&gt; 0.5.2&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/pact_elixir .","ref":"readme.html#installation","title":"PactElixir - Installation","type":"extras"},{"doc":"This is an example test case: defmodule PactElixir.PactMockServerTest do use ExUnit.Case alias PactElixir . { PactMockServer , ServiceProvider } import PactElixir.Dsl setup do options = %{ provider : &quot;SomeProvider&quot; , consumer : &quot;SomeConsumer&quot; } provider = new_service_provider ( options ) { :ok , mock_server_pid } = start_supervised ( { PactMockServer , provider } ) { :ok , mock_server_pid : mock_server_pid , provider : provider } end describe &quot;SomeProvider talks to SomeConsumer&quot; do test &quot;some basic test&quot; , %{ mock_server_pid : mock_server_pid } do expected = &quot;{groups: [&#39;Editors&#39;], id: 123, username: &#39;UserA&#39;}&quot; user ( mock_server_pid ) assert expected == user ( mock_server_pid ) . body assert { :ok } == PactMockServer . write_pact_file ( mock_server_pid ) end end defp get_request ( path , mock_server_pid ) when is_pid ( mock_server_pid ) do get_request ( path , PactMockServer . port ( mock_server_pid ) ) end defp get_request ( path , port ) when is_number ( port ) do % HTTPoison.Response { } = HTTPoison . get! ( &quot;http://localhost: \#{ port } \#{ path } &quot; ) end def user ( mock_server_pid ) do get_request ( &quot;/users/UserA&quot; , mock_server_pid ) end defp new_service_provider ( options \\\\ %{ } ) do options |&gt; PactElixir.Dsl . service_provider ( ) |&gt; add_interaction ( &quot;give me foo&quot; , given ( &quot;UserA exists and is not an administrator&quot; ) , with_request ( method : :get , path : &quot;/users/UserA&quot; ) , will_respond_with ( status : 200 , body : &quot;{groups: [&#39;Editors&#39;], id: 123, username: &#39;UserA&#39;}&quot; ) ) end end You should be able to run it with mix test &lt;path_to_test_case&gt; . Publishing If the test passes, a json file will be created and saved in a new directory - ./pacts . Currently, pact publishing is not yet implemented in this library. You can run the following bash script for your basic publishing needs: #!/bin/bash # This script: # 1) extracts the name of provider and consumer from the name of a JSON pact file # e.g.: Consumer1-Provider.json gives you consumer Consumer1 and provider Provider # 2) reads the JSON pact file from /pacts directory (pacts are stored there by specification) # 3) publishes pact to Pact Broker for pact in ./pacts/*.json; do pact_name=$(basename $pact) consumer=${pact_name%-*} provider=${pact_name#*-} provider=${provider%.*} curl -v -XPUT \\-H &quot;Content-Type: application/json&quot; \\ -d@${pact} \\ https://&lt;your-pact-broker-url&gt;/pacts/provider/$provider/consumer/$consumer/version/&lt;some-version-number&gt; done","ref":"readme.html#examples","title":"PactElixir - Examples","type":"extras"},{"doc":"Compiling NIF crate :pactmockserver ( native / pactmockserver ) ... could not compile dependency :pact_elixir , &quot;mix compile&quot; failed . You can recompile this dependency with &quot;mix deps.compile pact_elixir&quot; , update it with &quot;mix deps.update pact_elixir&quot; or clean it with &quot;mix deps.clean pact_elixir&quot; This can be solved by ensuring proper structure of mix.exs . Ensure you have rustler listed in compilers Ensure pactmockserver is listed in rustler_crates def project do [ #... compilers : [ :phoenix , :rustler ] ++ Mix . compilers ( ) , rustler_crates : rustler_crates ( Mix . env ( ) ) , #... ] end (This is an example setting, where you don't want to ship any rustler crates to production. Bottom line is, there has to be a function that returns the crates list, including pactmockserver). defp rustler_crates ( mix_env ) when mix_env in [ :test , :dev ] do [ pactmockserver : [ path : &quot;deps/pact_elixir/native/pactmockserver&quot; , mode : ( :debug ) , ] ] end defp rustler_crates ( _prod ) do [ ] end Docker Properly installing Rust should solve a majority of the problems. Just add the following code (this is for a Debian distro, it assumes you have curl installed): # Rust is required by pact-elixir RUN curl https://sh.rustup.rs -sSf | sh -s -- -y ENV PATH=$HOME/.cargo/bin:$PATH","ref":"readme.html#troubleshooting","title":"PactElixir - Troubleshooting","type":"extras"}]